package com.jeeplus.modules.sg.information.utils;

import com.jeeplus.common.utils.IdGen;
import com.jeeplus.common.utils.SpringContextHolder;
import com.jeeplus.common.utils.excel.ImportExcel;
import com.jeeplus.modules.sg.information.entity.Information;
import com.jeeplus.modules.sg.information.entity.append;
import com.jeeplus.modules.sg.information.service.InformationService;
import com.jeeplus.modules.sg.material.entity.Material;
import com.jeeplus.modules.sg.material.service.MaterialService;
import com.jeeplus.modules.sys.entity.User;
import com.jeeplus.modules.sys.utils.UserUtils;
import org.apache.poi.ss.usermodel.Row;
import org.springframework.beans.factory.annotation.Autowired;

import javax.validation.ConstraintViolationException;
import java.text.SimpleDateFormat;
import java.util.*;

public  class ImportInformation {
    @Autowired
    private static InformationService informationService = SpringContextHolder.getBean(InformationService.class);
    @Autowired
    private static MaterialService materialService = SpringContextHolder.getBean(MaterialService.class);

    /**
     * 导入欠供物资Excel数据
     */
    public static Map<String,Object> importmation(ImportExcel ei,int lastDataRowNum){
        HashMap<String,Object> hashMap = new HashMap<String,Object>();
        int successNum = 0;
        int failureNum = 0;
        List<Material> materials = new ArrayList<Material>();
        List<Material> errorMaterial = new ArrayList<Material>();
        List<Material> noDifferent = new ArrayList<>();
        User user = UserUtils.getUser();
        Double difference = 0.0;
        for (int i = 1; i < lastDataRowNum; i++) {
            Material material = new Material();
            try {
                Row row = ei.getRow(i);
                Object projectId = ei.getCellValue(row, 1);
                Object inforId = ei.getCellValue(row, 3);
                Object materialName = ei.getCellValue(row, 4);
                Object outboundAmount = ei.getCellValue(row, 5);
                Object authorizedAmount = ei.getCellValue(row, 6);
                Object outboundNumber = ei.getCellValue(row, 8);
                Object authorizedNumber = ei.getCellValue(row, 9);
                Object price = ei.getCellValue(row, 11);
                Object unit = ei.getCellValue(row, 12);
                Object materialSmall = ei.getCellValue(row, 13);
                Object materialMid = ei.getCellValue(row, 14);
                Object materialBig = ei.getCellValue(row, 15);

                String isBack = "";


                if (outboundAmount.equals("")) {
                    outboundAmount = "0.0";
                }
                if (authorizedAmount.equals("")) {
                    authorizedAmount = "0.0";
                }
                if (outboundNumber.equals("")) {
                    outboundNumber = "0.0";
                }
                if (authorizedNumber.equals("")) {
                    authorizedNumber = "0.0";
                }
                if (price.equals("")) {
                    price = "0.0";
                }
                difference = Double.parseDouble(outboundNumber.toString()) - Double.parseDouble(authorizedNumber.toString());


/*                Material myMaterial = materialService.findByProIn(projectId.toString(), inforId.toString());
                if (myMaterial != null) {
                    if (!myMaterial.getOutboundNumber().equals(Double.parseDouble(outboundNumber.toString()))) {
                        material.setInforId(inforId.toString());
                        material.setProjectId(projectId.toString());
                        material.setMaterialName(materialName.toString());
                        material.setOutboundAmount(Double.parseDouble(outboundAmount.toString()));
                        material.setAuthorizedAmount(Double.parseDouble(authorizedAmount.toString()));;
                        material.setDifference(difference);
                        material.setOutboundNumber(Double.parseDouble(outboundNumber.toString()));
                        material.setAuthorizedNumber(Double.parseDouble(authorizedNumber.toString()));
                        material.setPrice(Double.parseDouble(price.toString()));
                        material.setUnit(unit.toString());
                        material.setMaterialSmall(materialSmall.toString());
                        material.setMaterialMid(materialMid.toString());
                        material.setMaterialBig(materialBig.toString());
                        material.preInsert();
                        material.setIsBack(isBack);
                        material.setCreateBy(user);
                        material.setCreateDate(new Date());
                        material.setUpdateBy(user);
                        material.setUpdateDate(new Date());
                        errorMaterial.add(material);
                        continue;
                    }
                }*/
                if (difference == 0.0) {
                    isBack = "是";
                } else {
                    isBack = "否";
                }


                material.setInforId(inforId.toString());
                material.setProjectId(projectId.toString());
                material.setMaterialName(materialName.toString());
                material.setOutboundAmount(Double.parseDouble(outboundAmount.toString()));
                material.setAuthorizedAmount(Double.parseDouble(authorizedAmount.toString()));;
                material.setDifference(difference);
                material.setOutboundNumber(Double.parseDouble(outboundNumber.toString()));
                material.setAuthorizedNumber(Double.parseDouble(authorizedNumber.toString()));
                material.setPrice(Double.parseDouble(price.toString()));
                material.setUnit(unit.toString());
                material.setMaterialSmall(materialSmall.toString());
                material.setMaterialMid(materialMid.toString());
                material.setMaterialBig(materialBig.toString());
                material.preInsert();
                material.setIsBack(isBack);
                material.setCreateBy(user);
                material.setCreateDate(new Date());
                material.setUpdateBy(user);
                material.setUpdateDate(new Date());
                materials.add(material);

                successNum++;

                if (materials.size() == 1000) {
                    materialService.saveMater(materials);
                    List<Material> materials1 = materialService.projectNeed(materials);
                    if (materials1.size() >0) {
                        for (Material m : materials1) {
                            noDifferent.add(m);
                        }
                    }
                    materials.clear();
                }
            }catch (Exception ex) {
                ex.getMessage();
                failureNum++;
            }

        }
        if (materials.size() != 0) {
            materialService.saveMater(materials);
            List<Material> materials1 = materialService.projectNeed(materials);
            if (materials1.size() >0) {
                for (Material m : materials1) {
                    noDifferent.add(m);
                }
            }
        }
        if (noDifferent.size()>0){
            informationService.updateDate(noDifferent);
        }


        hashMap.put("errorMaterial", errorMaterial);
        hashMap.put("successNum",successNum);
        hashMap.put("failureNum",failureNum);
        return hashMap;
    }


    /**
     *	导入综合信息Excel数据
     * */
    public static Map<String,Integer> importCom(ImportExcel ei,int lastDataRowNum) {
        HashMap<String,Integer> hashMap = new HashMap<String,Integer>();
        int successNum = 0;
        int failureNum = 0;
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
        List<Information> informationList = new ArrayList<>();
        User user = UserUtils.getUser();
        String firstFinish = "";
        for (int i = 2; i < lastDataRowNum; i++) {
            Information information = new Information();
            try {
                Row row = ei.getRow(i);
                Object projectId = ei.getCellValue(row, 1);
                Object projectName = ei.getCellValue(row, 2);
                Object projectType = ei.getCellValue(row, 3);
                if (projectType.equals("配网建设改造项目")||projectType.equals("配网专项成本")){
                Object projectGrade = ei.getCellValue(row, 4);
                Object projectYear = ei.getCellValue(row, 6);
                Object projectTotal = ei.getCellValue(row, 7);
                Object projectStart = ei.getCellValue(row, 14);
                Object projectStop = ei.getCellValue(row, 15);
                Object department = ei.getCellValue(row, 16);
                Object projectFirm = ei.getCellValue(row, 38);
                Object subDate = ei.getCellValue(row, 40);
                Object releaseDate = ei.getCellValue(row, 41);
                Object endDate = ei.getCellValue(row, 42);
                Object resultDate = ei.getCellValue(row, 43);
                Object approvalDate = ei.getCellValue(row, 44);
                Object secondUnits = ei.getCellValue(row, 53);
                Object firstUnits = ei.getCellValue(row, 54);
                firstFinish = "否";

                if (projectTotal.equals("")) {
                    projectTotal = "0.0";
                }
                if (projectId.equals("")) {
                    continue;
                }
                information.setProjectId(projectId.toString());
                information.setProjectName(projectName.toString());
                information.setProjectType(projectType.toString());
                information.setProjectGrade(projectGrade.toString());
                information.setProjectYear(projectYear.toString());
                information.setProjectTotal(Double.parseDouble(projectTotal.toString()));
                if (!projectStart.equals("")&&projectStart!=null) {
                    information.setProjectStart(simpleDateFormat.parse(projectStart.toString()));
                }
                if (!projectStop.equals("")&&projectStop!=null) {
                    information.setProjectStop(simpleDateFormat.parse(projectStop.toString()));
                }
                information.setDepartment(department.toString());
                information.setProjectFirm(projectFirm.toString());
                if (!subDate.equals("")&&subDate!=null) {
                    information.setSubDate(simpleDateFormat.parse(subDate.toString()));
                }
                if (!releaseDate.equals("")&&releaseDate!=null) {
                    information.setReleaseDate(simpleDateFormat.parse(releaseDate.toString()));
                }
                if (!endDate.equals("")&&endDate!=null) {
                    information.setEndDate(simpleDateFormat.parse(endDate.toString()));
                }
                if (!resultDate.equals("")&&resultDate!=null) {
                    information.setResultDate(simpleDateFormat.parse(resultDate.toString()));
                }
                if (!approvalDate.equals("")&&approvalDate!=null) {
                    information.setApprovalDate(simpleDateFormat.parse(approvalDate.toString()));
                }
                information.setSecondUnits(secondUnits.toString());
                information.setFirstUnits(firstUnits.toString());
                information.setFirstFinish(firstFinish);
                information.preInsert();
                information.setCreateBy(user);
                information.setCreateDate(new Date());
                information.setUpdateBy(user);
                information.setUpdateDate(new Date());
                informationList.add(information);
                successNum++;
            }
                if (informationList.size() == 1000) {
                    informationService.saveInfo(informationList);
                    informationList.clear();
                }
            } catch (Exception ex) {
                failureNum++;
            }

        }
        if (informationList.size() != 0) {
            informationService.saveInfo(informationList);
        }
        hashMap.put("successNum",successNum);
        hashMap.put("failureNum",failureNum);
        return hashMap;
    }


    public static Map<String,Integer> importInTrial(ImportExcel ei,int lastDataRowNum) {
        HashMap<String,Integer> hashMap = new HashMap<String,Integer>();
        List<append> appendList = new ArrayList<>();
        int successNum = 0;
        int failureNum = 0;
        for (int i = 1; i < lastDataRowNum; i++) {
            try {
                append append = new append();
                Row row = ei.getRow(i);
                Object projectId = ei.getCellValue(row, 0);
                Object trial = ei.getCellValue(row, 1);
                Object construction = ei.getCellValue(row, 2);
                Object outConstruction = ei.getCellValue(row, 3);
                Object settlement = ei.getCellValue(row, 4);

                append.setProjectId(projectId.toString());
                append.setTrial(trial.toString());
                append.setConstruction(construction.toString());
                append.setOutConstruction(outConstruction.toString());
                append.setSettlement(settlement.toString());
                appendList.add(append);
                if (appendList.size() == 1000) {
                    informationService.updateAppend(appendList);
                    successNum = successNum + appendList.size();
                    appendList.clear();
                }
            } catch (Exception e) {
                failureNum++;
            }
        }
        if (appendList.size() != 0) {
            informationService.updateAppend(appendList);
            successNum = successNum + appendList.size();
        }
        hashMap.put("successNum",successNum);
        hashMap.put("failureNum",failureNum);
        return hashMap;
    }


}
